    001/*
    002 * Licensed to the Apache Software Foundation (ASF) under one or more
    003 * contributor license agreements.  See the NOTICE file distributed with
    004 * this work for additional information regarding copyright ownership.
    005 * The ASF licenses this file to You under the Apache License, Version 2.0
    006 * (the "License"); you may not use this file except in compliance with
    007 * the License.  You may obtain a copy of the License at
    008 *
    009 *      https://www.apache.org/licenses/LICENSE-2.0
    010 *
    011 * Unless required by applicable law or agreed to in writing, software
    012 * distributed under the License is distributed on an "AS IS" BASIS,
    013 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    014 * See the License for the specific language governing permissions and
    015 * limitations under the License.
    016 */
    017
    018package org.apache.commons.codec;
    019
    020/**
    021 * Provides the highest level of abstraction for Encoders.
    022 * <p>
    023 * This is the sister interface of {@link Decoder}.  Every implementation of Encoder provides this
    024 * common generic interface which allows a user to pass a generic Object to any Encoder implementation
    025 * in the codec package.
    026 * </p>
    027 */
    028public interface Encoder {
    029
    030    /**
    031     * Encodes an "Object" and returns the encoded content as an Object. The Objects here may just be
    032     * {@code byte[]} or {@code String}s depending on the implementation used.
    033     *
    034     * @param source
    035     *            An object to encode
    036     * @return An "encoded" Object
    037     * @throws EncoderException
    038     *             An encoder exception is thrown if the encoder experiences a failure condition during the encoding
    039     *             process.
    040     */
    041    Object encode(Object source) throws EncoderException;
    042}
    043